﻿using System;

namespace WcfRestServiceDemo.Data
{
    partial class WcfRestServiceDemoContainer
    {
        public static void Go(Action<WcfRestServiceDemoContainer> todo, bool isLazy = false)
        {
            Go<object>(entities =>
            {
                todo(entities);
                return null;
            },
                isLazy);
        }

        public static void GoAndSave(Action<WcfRestServiceDemoContainer> todo, bool isLazy = false)
        {
            Go<object>(entities =>
            {
                todo(entities);
                entities.SaveChanges();
                return null;
            },
                isLazy);
        }

        public static T Go<T>(Func<WcfRestServiceDemoContainer, T> todo, bool isLazy = false)
        {
            using(var entities = new WcfRestServiceDemoContainer())
            {
                entities.ContextOptions.LazyLoadingEnabled = isLazy;
                entities.ContextOptions.ProxyCreationEnabled = false;
                return todo(entities);
            }
        }

        public static T GoAndSave<T>(Func<WcfRestServiceDemoContainer, T> todo, bool isLazy = false)
        {
            return Go(entities =>
            {
                var result = todo(entities);
                entities.SaveChanges();
                return result;
            },
                isLazy);
        }
    }
}